/***********************************************
*  FreeRTOS Test Program sample5
*  Semaphore Interrupt Control
***********************************************/
#include <p24FJ128GA010.h>
#include "FreeRTOS.h"					/* FreeRTOSwb_ */
#include "task.h"
#include "queue.h"
#include <timer.h>
#include <Lcd_Lib32.h>
/***  RtBM[Vݒ  ***/
_CONFIG1(JTAGEN_OFF & GCP_OFF & GWRP_OFF & BKBUG_OFF & COE_OFF & FWDTEN_OFF & ICS_PGx2) 
// 8MHz*PLL4=32MHz (Full Speed)
_CONFIG2(IESO_OFF & FCKSM_CSDCMD & OSCIOFNC_OFF & POSCMOD_HS & FNOSC_PRIPLL)

/* ϐ`*/
xQueueHandle numQueue, lcdQueue;
/* ֐vg */
void vTask1( void *pvParameters );			// ^XNP
void vTask2( void *pvParameters );			// ^XNQ
void itostring(char digit, unsigned int data, char *buffer);

/****************** C֐ ************************/
int main(void){
	/* VXeݒ */
	AD1PCFG = 0xFFFF;						// ׂăfW^I/O
	LATA = 0;							// I/Oݒ
	TRISA = 0;
	// LCD̏ݒƏ\
	TRISE = 0x0100;						// LCDp RE8 INT1
	TRISDbits.TRISD4 = 0;					// LCDp
	TRISDbits.TRISD5 = 0;					// LCDp
	LCD_WR = 0;							// WR͏Low
	TRISBbits.TRISB15 = 0;					// LCDp
	delay_ms(500);						// 0.5secԕ\
	lcd_init();							// LCD
	lcd_clear();							// S
	lcd_str("Start!");					// JnbZ[W
	delay_ms(500);						// 0.5secԕ\
	// ^C}Qݒ 62.5nsec*64*50000=200msec
	OpenTimer2(T2_ON & T2_SOURCE_INT & T2_PS_1_64 & T2_GATE_OFF, 50000);
	ConfigIntTimer2(T2_INT_ON & T2_INT_PRIOR_4);
	/* L[obt@@*/
	lcdQueue = xQueueCreate(10, 17);		// \L[17Byte x 5
	numQueue = xQueueCreate(10, 2);			// lL[1byte x 10
	/* ^XN  */
	xTaskCreate( vTask1, (signed portCHAR *)"T1", 100, NULL, 1, NULL );
	xTaskCreate( vTask2, (signed portCHAR *)"T2", 100, NULL, 1, NULL );
	/* XPW[OJn@*/
	vTaskStartScheduler();
	/********@C[v  *******/
	while(1)
	{	}
}

/**** ^C}Q荞ݏ *****/
void __attribute__ ((interrupt, no_auto_psv)) _T2Interrupt(void)
{
	static unsigned int pos, RcvNumber;
	static portBASE_TYPE xHigherTaskWoken;
	static char Buf[] = "                ";

	LATA ^= 0x40;
	IFS0bits.T2IF = 0;						// 荞݃tONA
	pos = 0;									// \ʒu
	// lL[oϊ\L[֑M
	xHigherTaskWoken = pdFALSE;
	while(xQueueReceiveFromISR(numQueue, &RcvNumber,&xHigherTaskWoken) != errQUEUE_EMPTY)
	{
		RcvNumber &= 0x07;					// 3rbĝ(0-7̐l)
		itostring(1, RcvNumber, Buf+pos);		// posŕ\ʒuVtg
		pos += 2;							// 2
		xQueueSendToBackFromISR(lcdQueue, Buf, &xHigherTaskWoken);
	}
}

/***** ^XN1֐ ******/
void vTask1(void *pvParameters){
	portTickType xLastExecutionTime;
	static char Msg1[] = "Task1Count=xxxxx";
	static unsigned int Count1 = 0;
	unsigned int i;

	xLastExecutionTime = xTaskGetTickCount();	// ݃`bN
	while(1)	{	// 1bƂɋN
		vTaskDelayUntil(&xLastExecutionTime, 1000/portTICK_RATE_MS);
		LATA ^= 0x80;							// LED_
		for(i=0; i<5; i++){					// 5̐lL[ɑM
			xQueueSendToBack(numQueue, &Count1, 0);
			Count1++;						// lCNg
		}
		itostring(5, Count1, Msg1+11);			// bZ[Wp
		/* L[ɓo^ */
		xQueueSendToBack(lcdQueue, Msg1, portMAX_DELAY);
	}
}
/***** ^XN2֐ ******/
void vTask2(void *pvParameters){
	char Buf[32];

	while(1) {

		/* L[f[^o */
		xQueueReceive(lcdQueue, Buf, portMAX_DELAY);
		// bZ[WLCD\
		if(Buf[0] == 'T'){
			lcd_cmd(0x80);				// 1sڂ
			LATA ^= 0x20;					// LED_
		}
		else{
			lcd_cmd(0xC0);				// 2sڂ
			LATA ^= 0x10;					// LED_
		}
		lcd_str(Buf);						// \s
	}
}

/*****************************************
*   l當ɕϊ
*****************************************/
void itostring(char digit, unsigned int data, char *buffer)
{
	char i;

	buffer += digit;						//̍Ō
	for(i=digit; i>0; i--) {				//ŉʌʂ
		buffer--;						//|C^[P
		*buffer = (data % 10) + '0';		//̌l𕶎ɂĊi[
		data = data / 10;					//-1
	}
}
